#include "ej10.h"
#include <iostream>

using namespace std;

Nodo::Nodo(int v) : dato(v), siguiente(0) {}
Nodo::Nodo(int v, Nodo* sig) : dato(v), siguiente(sig) {}

Lista::Lista() : primero_(0) { }

Lista::~Lista() {
  Nodo* tmp = primero_;
  while (tmp != 0) {
    Nodo* aux = tmp;
    tmp = tmp->siguiente;
    delete aux;
  }
}

void Lista::imprime() {
  cout << "lista: ";
  Nodo* tmp = primero_;
  while (tmp != 0) {
    cout << tmp->dato << " ";
    tmp = tmp->siguiente;
  }
  cout << " longitud: " << longitud() << endl;
}


Nodo *Lista::ultimo() {
  Nodo* tmp = primero_;

  while (tmp->siguiente != 0) {
    tmp = tmp->siguiente;
  }
  return tmp;
}

void Lista::insertaFinal(int dato) {
  Nodo* aux = new Nodo(dato);
  if (primero_ == 0) {
    primero_ = aux;
  }
  else {
    Nodo* ultim = ultimo();
    ultim->siguiente = aux;
  }
}

void Lista::insertaPpio(int dato) {
  Nodo* aux = new Nodo(dato,primero_);
  primero_ = aux;
}

void Lista::eliminaPos(int pos) {
  if (pos < 0 || pos >= longitud() ) {
    cout << "Error: posicion invalida" << endl;
    return;
  }

  if (pos == 0) {
    Nodo* tmp = primero_;
    primero_ = primero_->siguiente;
    delete tmp;
  }
  else {
    int prev_pos = pos-1;
    int tmp_pos = 0;
    Nodo* tmp = primero_;
    while (tmp_pos < prev_pos) {
      tmp = tmp->siguiente;
      tmp_pos++;
    }
    Nodo* aux = tmp->siguiente;
    tmp->siguiente = tmp->siguiente->siguiente;
    delete aux;
  }

}

int Lista::longitud() {
  int tamano = 0;
  Nodo* tmp = primero_;
  while (tmp != 0) {
    tamano++;
    tmp = tmp->siguiente;
  }
  return tamano;
}

int main() {
cout << "operador ->*" << endl;
  Lista lista;
  lista.imprime();
  lista.insertaFinal(3);
  lista.insertaPpio(2);
  lista.insertaFinal(4);
  lista.insertaPpio(1);
  lista.insertaFinal(5);
  lista.imprime();
  lista.eliminaPos(0);
  lista.imprime();
  lista.eliminaPos(lista.longitud()-1);
  lista.imprime();
  lista.eliminaPos(1);
  lista.imprime();
}
