#include "ej7-8.h"
#include <iostream>

using namespace std;

ArrayIntDinamico::ArrayIntDinamico() : miarray_(new int[MAX_TAM_INIT]), tamano_(MAX_TAM_INIT), ultima_pos_(0) {}

ArrayIntDinamico::ArrayIntDinamico(const ArrayIntDinamico& other) {
  ultima_pos_ = other.ultima_pos_;
  tamano_ = other.tamano_;

  delete miarray_;
  miarray_ = new int[tamano_];
  for (int i=0; i<ultima_pos_; i++) miarray_[i] = other.miarray_[i];

}

ArrayIntDinamico::~ArrayIntDinamico() {
  cout << "destructor" << endl;
  delete[] miarray_;
}

void ArrayIntDinamico::insertaFinal(const int num) {
  if (ultima_pos_ == tamano_) { // array lleno hay que incrementarlo
    cout << "llegado al limite del array=" << tamano_ << " ";
    tamano_ *= 2; 
    cout << "nuevo tamano=" << tamano_ << endl;

    int *newarray = new int (tamano_); // me copio los valores al nuevo array
    for (int i=0; i<ultima_pos_; i++) newarray[i] = miarray_[i];

    delete miarray_;
    miarray_ = newarray;
  }

  miarray_[ultima_pos_++] = num;
}

bool ArrayIntDinamico::esInvalida(int pos) {
  return pos < 0 || pos >= ultima_pos_;
}

int ArrayIntDinamico::getValor(int pos) {
  if ( esInvalida(pos) ) {
    cout << "Posicion " << pos << " erronea" << endl;
    return -1;
  }
  else {
    return miarray_[pos];
  }
}

void ArrayIntDinamico::eliminaValorDe(int pos) {
  if ( esInvalida(pos) ) {
    cout << "Posicion " << pos << " erronea" << endl;
  }
  else {
    for (int i=pos; i<ultima_pos_-1; i++) {
      miarray_[i] = miarray_[i+1];
    }
    ultima_pos_--;
  }
}

void ArrayIntDinamico::setValorDe(int pos, int valor) {
  if ( esInvalida(pos) ) {
    cout << "Posicion " << pos << " erronea" << endl;
  }
  else {
    miarray_[pos] = valor;
  }
}

void ArrayIntDinamico::vaciaContenido() {
  ultima_pos_ = 0;
}

void ArrayIntDinamico::imprime() {
  cout << "tamano: " << tamano_ << endl;
  cout << "ultima pos: " << ultima_pos_ << endl;

  cout << "Contenido: ";
  for (int i=0; i<ultima_pos_; i++) cout << getValor(i) << " ";
  cout << endl;
}

int main() 
{
  ArrayIntDinamico *miArrayDin = new ArrayIntDinamico();
  miArrayDin->insertaFinal(3);
  miArrayDin->insertaFinal(4);
  miArrayDin->insertaFinal(5);
  miArrayDin->imprime();
  miArrayDin->insertaFinal(6);
  miArrayDin->insertaFinal(7);
  miArrayDin->imprime();

  miArrayDin->eliminaValorDe(19);
  miArrayDin->eliminaValorDe(4);
  miArrayDin->imprime();
  miArrayDin->eliminaValorDe(0);
  miArrayDin->imprime();
  miArrayDin->eliminaValorDe(1);
  miArrayDin->imprime();

  miArrayDin->setValorDe(0,19);
  miArrayDin->imprime();

  miArrayDin->vaciaContenido();
  miArrayDin->imprime();


  delete miArrayDin;
}
